<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ConformidadesService;

class ConformidadesController extends FMCrud
{
    protected $ConformidadesService;

    public function __construct($crudService, $environment, $ConformidadesService) {
        parent::__construct($crudService, $environment);
        $this->ConformidadesService = $ConformidadesService;
    }
    
    // Função para buscar os dados do card de não conformidades
    public function getDadosCard(DTO\Request $request, DTO\Response $response) {
        $parametroFiltro = $request->getParameters();
        // debugApi($parametroFiltro);
        $variavel = $this->ConformidadesService->getDadosCardService($parametroFiltro);
        $dtsVal = new DataSet('dados', $variavel);
        $response->addDataSet($dtsVal);
    }
    
    // Função para buscar os dados do card de principais não conformidades
    public function getDadosCardPrincipaisNaoConformidades(DTO\Request $request, DTO\Response $response) {
        $parametroFiltro = $request->getParameters();
        $variavel = $this->ConformidadesService->getDadosCardPrincipaisNaoConformidades($parametroFiltro);
        $dtsVal = new DataSet('dadosCardPrincipais', $variavel);
        $response->addDataSet($dtsVal);
    }
    
    // função para pegar os dados de tipo local
    public function getTipoLocal(DTO\Request $request, DTO\Response $response) {
        $tipoLocal = $this->ConformidadesService->buscaTipoLocal();
        $dtsVal = new DataSet('tipoLocal', $tipoLocal);
        $response->addDataSet($dtsVal);
    }
    
    // função para pegar os dados do setor
    public function getSetor(DTO\Request $request, DTO\Response $response) {
        $setor = $this->ConformidadesService->buscaSetor();
        $dtsVal = new DataSet('setor', $setor);
        $response->addDataSet($dtsVal);
    }
    
    public function getDadosAcesso(DTO\Request $request, DTO\Response $response) {
    	$nrFuncionario = $request->getParameters();
    	$funcionario = $this->ConformidadesService->getDadosAcesso($nrFuncionario);
    	$dtsVal = new DataSet('acesso', $funcionario);
    	$response->addDataSet($dtsVal);
    }
    public function getlocalUrl(DTO\Request $request, DTO\Response $response) {
    	$paramUrl = $this->ConformidadesService->getlocalUrl($request->getParameters());
    	$dtsVal = new DataSet('local', $paramUrl);
    	$response->addDataSet($dtsVal);
    }
    
    public function getUrlLocaisNaoAlocados(DTO\Request $request, DTO\Response $response) {
    	$parametro = $request->getParameters();
    	$paramUrl = $this->ConformidadesService->getTarefaVistoriaNaoAlocado($parametro);
    	$dtsVal = new DataSet('local', $paramUrl);
    	$response->addDataSet($dtsVal);
    }
    
    public function getCriterioNaoConformidadeByGestor(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $data = $this->ConformidadesService->getCriterioNaoConformidadeByGestor($params);
        $dtsVal = new DataSet('conformidadesGestor', $data);
        $response->addDataSet($dtsVal);
    }

}
?>