<?php

namespace FM\Traits;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Zeedhi\Framework\Remote\cURLRequest;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

trait TFileUpload {
    
    public function uploadImages($params, $nrorg) {
        
        if (isset(InstanceManager::getInstance()->getParameter('fileServerApiKeys')[$nrorg])) {
            $key = InstanceManager::getInstance()->getParameter('fileServerApiKeys')[$nrorg];
            $fileServerUrl = InstanceManager::getInstance()->getParameter('fileServerUrl');
            $zhFileUploader = new Server(new cURLRequest($fileServerUrl . "/index.php"), $key);
            $customFolder = "FOTOS_FMSM";
            $row = array('FILE' => $params);
            $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);
            $paramsFoto = [];
            foreach ($row['FILE'] as $file) {
                $paramsFoto[] = [
                    "NOME" => $file['name'],
                    "PATH" => $file['path'],
                    "DS" => $fileServerUrl . "/files/" . $file["path"],
                    "DSTYPE" => $file["type"],
                    "NRSIZE" => $file["size"]
                ];
            }
            return $paramsFoto;
        }
        else {
            throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado.");
        }
    }
}