CREATE OR REPLACE TRIGGER USR_ALTERACAOAF
BEFORE DELETE OR UPDATE OF VRTOTALAF
ON AUTOFORNE FOR EACH ROW
DECLARE
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);
   V_NOVOCODIGO    INTEGER;
   V_FILIAL        VARCHAR2(10);
   V_MAIORCOD      INTEGER;
   V_PRXCODIGO     VARCHAR2(20);
BEGIN
   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDGRUPFILI = '9999999999'
      AND CDFILIAL = :OLD.CDFILDEST;

   IF NOT V_FILIAL IS NULL THEN
      IF UPDATING THEN
         :NEW.USR_DTEXPORTA := NULL;
      ELSE
         V_MAIORCOD := 0;
         /* Retorna data e hora de exportao */
         BEGIN
            SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
              INTO V_DTGRV, V_HRGRV
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTGRV := NULL;
               V_HRGRV := NULL;
         END;

         /* Retorna o sequencial para a tabela */
         NOVO_CODIGO_SC('USR_INT_AUTOFORNE', V_PRXCODIGO);
         V_NOVOCODIGO := TO_NUMBER(SUBSTR(V_PRXCODIGO,11,10));

         SELECT MAX(NRSEQUENCIAL)
         INTO V_MAIORCOD
         FROM USR_INT_AUTOFORNE
         WHERE CDFILDEST = :OLD.CDFILDEST
           AND CDFILLANC = :OLD.CDFILLANC
           AND NRAUTOFORN = :OLD.NRAUTOFORN
           AND IDTPEXPITSOL = '1'
           AND IDORIGREGISTRO = 'T';

         FOR C_AUTOFORNE IN (
            SELECT
               NRSEQUENCIAL, CDFILDEST, CDFILLANC, NRAUTOFORN,
               CDEMPRESA, DTAUTOFORN, CDFORNECED, NMCONTFORN,
               CDFORMPGTO, VRDESCONTO1, VRDESCONTO2, VRRETSEGSOCIAL,
               VRTOTALAF, CDOPERADOR
              FROM USR_INT_AUTOFORNE
             WHERE CDFILDEST = :OLD.CDFILDEST
               AND CDFILLANC = :OLD.CDFILLANC
               AND NRAUTOFORN = :OLD.NRAUTOFORN
               AND NRSEQUENCIAL = V_MAIORCOD)
         LOOP
            INSERT INTO USR_INT_AUTOFORNE
                (NRSEQUENCIAL, CDFILDEST, CDFILLANC, NRAUTOFORN,
                 CDEMPRESA, DTAUTOFORN, CDFORNECED, NMCONTFORN,
                 CDFORMPGTO, VRDESCONTO1, VRDESCONTO2, VRRETSEGSOCIAL,
                 VRTOTALAF, DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO,
                 IDTPEXPITSOL, IDORIGREGISTRO, CDOPERADOR)
            VALUES
                (V_NOVOCODIGO, :OLD.CDFILDEST, :OLD.CDFILLANC, :OLD.NRAUTOFORN,
                 C_AUTOFORNE.CDEMPRESA, C_AUTOFORNE.DTAUTOFORN, C_AUTOFORNE.CDFORNECED, C_AUTOFORNE.NMCONTFORN,
                 C_AUTOFORNE.CDFORMPGTO, C_AUTOFORNE.VRDESCONTO1, C_AUTOFORNE.VRDESCONTO2, C_AUTOFORNE.VRRETSEGSOCIAL,
                 C_AUTOFORNE.VRTOTALAF, V_DTGRV, V_HRGRV, NULL, NULL, '2', 'T', C_AUTOFORNE.CDOPERADOR);
         END LOOP;

         FOR C_ITEXCL IN
            (SELECT
                NRSEQUENCIAL,NRSEQITEM,CDFILDEST,CDFILLANC,NRAUTOFORN,
                CDMARCA,CDPRODUTO,DTPROGENTAF,NMPRODUTO,VRQTDEAF,VRPRECOUNIT,
                VRTOTALITEM,VRIVAMP,VRIMPINT02,VRPIBBA,VRPERCIVA,
                VRABASTOS,VRPIBCP,VRPIBCBA,VRPIBSFE,VRPIBMZA,VRPIBSJ,VRPIBCAT,
                VRPIBTUC,VRPIBCTE,VRPIBSAL,VRPIBSL,VRPIBTF,VRIVAOC,VRIVA19,VRIVA20,
                VRIMPINT21,VRPIBMIS,VRPIIBBTUC,TXOBSITMAF,IDTPEXPITSOL,IDORIGREGISTRO,
                DTGRAVACAO,HRGRAVACAO,DTIMPORTACAO,HRIMPORTACAO,
                CDSOLPORTAL, NRITEMSOLPORTAL, NRSOLTEKNISA, NRSOLPORTAL, CDAFPORTAL, NRAFPORTAL, NRITAFPORTAL
              FROM  USR_INT_ITEMAUTF
              WHERE CDFILDEST = :OLD.CDFILDEST
                AND CDFILLANC = :OLD.CDFILLANC
                AND NRAUTOFORN = :OLD.NRAUTOFORN
                AND NRSEQUENCIAL = V_MAIORCOD
                AND IDTPEXPITSOL = '1'
                AND IDORIGREGISTRO = 'T'
              ORDER BY CDMARCA, CDPRODUTO, DTPROGENTAF)
         LOOP
            INSERT INTO USR_INT_ITEMAUTF
               (NRSEQUENCIAL,NRSEQITEM,CDFILDEST,CDFILLANC,NRAUTOFORN,
                CDMARCA,CDPRODUTO,DTPROGENTAF,NMPRODUTO,VRQTDEAF,VRPRECOUNIT,
                VRTOTALITEM,VRIVAMP,VRIMPINT02,VRPIBBA,VRPERCIVA,
                VRABASTOS,VRPIBCP,VRPIBCBA,VRPIBSFE,VRPIBMZA,VRPIBSJ,VRPIBCAT,
                VRPIBTUC,VRPIBCTE,VRPIBSAL,VRPIBSL,VRPIBTF,VRIVAOC,VRIVA19,VRIVA20,
                VRIMPINT21,VRPIBMIS,VRPIIBBTUC,TXOBSITMAF,IDTPEXPITSOL,IDORIGREGISTRO,
                DTGRAVACAO,HRGRAVACAO,DTIMPORTACAO,HRIMPORTACAO,
                CDSOLPORTAL, NRITEMSOLPORTAL, NRSOLTEKNISA, NRSOLPORTAL, CDAFPORTAL, NRAFPORTAL, NRITAFPORTAL)
            VALUES
               (V_NOVOCODIGO, C_ITEXCL.NRSEQITEM, C_ITEXCL.CDFILDEST, C_ITEXCL.CDFILLANC,C_ITEXCL.NRAUTOFORN,
                C_ITEXCL.CDMARCA,C_ITEXCL.CDPRODUTO, C_ITEXCL.DTPROGENTAF,C_ITEXCL.NMPRODUTO,C_ITEXCL.VRQTDEAF, C_ITEXCL.VRPRECOUNIT,
                C_ITEXCL.VRTOTALITEM,C_ITEXCL.VRIVAMP,C_ITEXCL.VRIMPINT02,C_ITEXCL.VRPIBBA,C_ITEXCL.VRPERCIVA,
                C_ITEXCL.VRABASTOS,C_ITEXCL.VRPIBCP,C_ITEXCL.VRPIBCBA,C_ITEXCL.VRPIBSFE,C_ITEXCL.VRPIBMZA,C_ITEXCL.VRPIBSJ,C_ITEXCL.VRPIBCAT,
                C_ITEXCL.VRPIBTUC,C_ITEXCL.VRPIBCTE,C_ITEXCL.VRPIBSAL,C_ITEXCL.VRPIBSL,C_ITEXCL.VRPIBTF,C_ITEXCL.VRIVAOC,C_ITEXCL.VRIVA19,C_ITEXCL.VRIVA20,
                C_ITEXCL.VRIMPINT21,C_ITEXCL.VRPIBMIS,C_ITEXCL.VRPIIBBTUC,C_ITEXCL.TXOBSITMAF,'2','T',
                V_DTGRV,V_HRGRV, NULL, NULL,
                C_ITEXCL.CDSOLPORTAL, C_ITEXCL.NRITEMSOLPORTAL, C_ITEXCL.NRSOLTEKNISA, C_ITEXCL.NRSOLPORTAL, C_ITEXCL.CDAFPORTAL, C_ITEXCL.NRAFPORTAL, C_ITEXCL.NRITAFPORTAL);
         END LOOP;
      END IF;
   END IF;
END;
