/* Dados Mestres de ECF - Sadas */
CREATE TABLE IN86_ARQ_ECFM
(
    CDEMPRSAP            VARCHAR2(09)     not null,
    CDFILIAL             VARCHAR2(09)     not null,
    NRECFREDZ            VARCHAR2(06)     not null,
    DTREDUCAOZ           DATE             not null,
    CDMAPRESUMO          VARCHAR2(10)     null,
    NRPRIMCFREDZ         VARCHAR2(06)     null,
    NRULTCFREDZ          VARCHAR2(06)     null,
    VRREDZ               FLOAT            null,
    VRGRTOTAL            FLOAT            null,
    NRREDREDZ            VARCHAR2(06)     null,
    NRREINIREDZ          VARCHAR2(03)     null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO1            VARCHAR2(150)    null,
    DSESPACO2            VARCHAR2(150)    null,
    DSESPACO3            VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

/* Dados de Itens de ECF - Sadas */
CREATE TABLE IN86_ARQ_ECFI
(
    CDEMPRSAP            VARCHAR2(09)     not null,
    CDFILIAL             VARCHAR2(09)     not null,
    NRECFREDZ            VARCHAR2(06)     not null,
    DTREDUCAOZ           DATE             not null,
    VRSITUTRIB           VARCHAR2(04)     not null,
    DSSITUTRIB           VARCHAR2(06)     null,
    VRACUMULADO          FLOAT            null,
    VRBASECALC           FLOAT            null,
    VRCONTABIL           FLOAT            null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO1            VARCHAR2(150)    null,
    DSESPACO2            VARCHAR2(150)    null,
    DSESPACO3            VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

/* Dados de Detalhe/Resumo do cupom ECF */
CREATE TABLE IN86_ARQ_ECFR
(
    CDEMPRSAP            VARCHAR2(09)     null,
    CDFILIAL             VARCHAR2(09)     null,
    DTENTRVENDA          DATE             null,
    NMCAIXA              VARCHAR2(20)     null,
    NRECFREDZ            VARCHAR2(06)     null,
    NRCUPOMFISC          VARCHAR2(06)     null,
    NRSEQUITVEND         VARCHAR2(03)     null,
    IDTPIMPOSFIS         VARCHAR2(04)     null,
    VRFIXO1              VARCHAR2(01)     null,
    VRFIXO2              VARCHAR2(03)     null,
    CDMATERIAL           VARCHAR2(20)     null,
    QTPRODVEND           FLOAT            null,
    VRUNITARIO           FLOAT            null,
    VRBASECALC           FLOAT            null,
    VRIMPOSTO            FLOAT            null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO1            VARCHAR2(150)    null,
    DSESPACO2            VARCHAR2(150)    null,
    DSESPACO3            VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

/* Controle de Estoque - Lanamentos */
CREATE TABLE IN86_ARQ_ESTL
(
    CDEMPRSAP            VARCHAR2(09)     null,
    CDFILIAL             VARCHAR2(09)     null,
    CDMP                 VARCHAR2(05)     null,
    DTLANCAMENTO         DATE             null,
    CDMATERIAL           VARCHAR2(20)     null,
    CDTIPOOPER           VARCHAR2(06)     null,
    QTPRODUTO            FLOAT            null,
    IDLANCAMENTO         VARCHAR2(01)     null,
    NRSEQITPROD          VARCHAR2(40)     null,
    CDTIPODOCU           VARCHAR2(03)     null,
    NRNOTAFISC           VARCHAR2(15)     null,
    CDSERIE              VARCHAR2(05)     null,
    NRITNF               VARCHAR2(15)     null,
    DSESPACO1            VARCHAR2(12)     null,
    CDCATEGORIAPFPJ      VARCHAR2(02)     null,
    CDPFPJ               VARCHAR2(16)     null,
    VRFIXO1              VARCHAR2(03)     null,
    VRUNITPROD           FLOAT            null,
    VRTOTAITEM           FLOAT            null,
    VRCUSTOUNIT          FLOAT            null,
    VRCUSTOTOT           FLOAT            null,
    CDCONTAESTOQ         VARCHAR2(28)     null,
    DSESPACO2            VARCHAR2(28)     null,
    DSESPACO3            VARCHAR2(14)     null,
    CDCENTCUST           VARCHAR2(28)     null,
    CDCFOPPROD           VARCHAR2(06)     null,
    VRIPIPROD            FLOAT            null,
    VRFIXO2              VARCHAR2(06)     null,
    DSESPACO4            VARCHAR2(10)     null,
    DSESPACO5            VARCHAR2(10)     null,
    DSESPACO6            VARCHAR2(04)     null,
    DSESPACO7            VARCHAR2(04)     null,
    DSESPACO8            VARCHAR2(04)     null,
    DSESPACO9            VARCHAR2(150)    null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO10           VARCHAR2(150)    null,
    DSESPACO11           VARCHAR2(150)    null,
    DSESPACO12           VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

/* Registro de Inventrio */
CREATE TABLE IN86_ARQ_ESTI
(
    CDEMPRSAP            VARCHAR2(09)     not null,
    CDFILIAL             VARCHAR2(09)     not null,
    CDMP                 VARCHAR2(05)     null,
    CDCENTCUST           VARCHAR2(28)     null,
    DTINVENTARIO         DATE             not null,
    CDMATERIAL           VARCHAR2(20)     not null,
    VRFIXO1              VARCHAR2(10)     null,
    VRFIXO2              VARCHAR2(03)     null,
    CDCONTAESTOQ         VARCHAR2(28)     null,
    QTPRODUTO            FLOAT            null,
    SGUNIDPROD           VARCHAR2(03)     null,
    VRCUSTOUNIT          FLOAT            null,
    VRCUSTOTOTA          FLOAT            null,
    DSESPACO1            VARCHAR2(04)     null,
    DSESPACO2            VARCHAR2(150)    null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO3            VARCHAR2(150)    null,
    DSESPACO4            VARCHAR2(150)    null,
    DSESPACO5            VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

/* Cadastro de Materiais */
CREATE TABLE IN86_ARQ_MAT
(
    CDEMPRSAP            VARCHAR2(09)     not null,
    CDFILIAL             VARCHAR2(09)     not null,
    CDMATERIAL           VARCHAR2(20)     not null,
    DTMOVIMENT           DATE             null,
    DSMATERIAL           VARCHAR2(150)    null,
    IDCLASMATERIAL       VARCHAR2(01)     null,
    VRFIXO1              VARCHAR2(10)     null,
    SGUNIDPROD           VARCHAR2(03)     null,
    VRFIXO2              VARCHAR2(01)     null,
    VRFIXO3              VARCHAR2(01)     null,
    VRFIXO4              VARCHAR2(01)     null,
    DSESPACO1            VARCHAR2(02)     null,
    DSESPACO2            VARCHAR2(01)     null,
    DSESPACO3            VARCHAR2(10)     null,
    DSESPACO4            VARCHAR2(10)     null,
    DSESPACO5            VARCHAR2(10)     null,
    DSESPACO6            VARCHAR2(30)     null,
    DSESPACO7            VARCHAR2(15)     null,
    DSESPACO8            VARCHAR2(15)     null,
    DSESPACO9            VARCHAR2(15)     null,
    DSESPACO10           VARCHAR2(15)     null,
    DSESPACO11           VARCHAR2(15)     null,
    DSTEC_WIN            VARCHAR2(150)    null,
    DTPROC               VARCHAR2(150)    null,
    DSESPACO12           VARCHAR2(150)    null,
    DSESPACO13           VARCHAR2(150)    null,
    DSESPACO14           VARCHAR2(150)    null,
    DSSEQZERO1           VARCHAR2(17)     null,
    DSSEQZERO2           VARCHAR2(17)     null,
    DSSEQZERO3           VARCHAR2(17)     null
)
/

CREATE INDEX ARQ_ECFM_FK ON IN86_ARQ_ECFM (CDFILIAL)
/

CREATE INDEX ARQ_ECFI_FK ON IN86_ARQ_ECFI (CDFILIAL)
/

CREATE INDEX ARQ_ECFR_FK ON IN86_ARQ_ECFR (CDFILIAL)
/

CREATE INDEX ARQ_ESTL_FK ON IN86_ARQ_ESTL (CDFILIAL)
/

CREATE INDEX ARQ_ESTI_FK ON IN86_ARQ_ESTI (CDFILIAL)
/

CREATE INDEX ARQ_MAT_FK ON IN86_ARQ_MAT (CDFILIAL)
/
