CREATE OR REPLACE PROCEDURE USR_EXPORTA_SOLCOMP(V_NOME IN VARCHAR)
IS

--ESPECIFICO TABELA INT
V_ERRO 		   VARCHAR2(5000);
V_OBS			   VARCHAR2(5000);

V_DTINI        DATE;
V_DTFIN        DATE;

BEGIN
   V_DTINI := TRUNC(SYSDATE - 1);
   V_DTFIN := TRUNC(SYSDATE + 730);

   FOR C_FILIAL IN (SELECT CDFILIAL, CDEXFILIAL
                      FROM PARAMFILIAL
                     WHERE NOT CDEXFILIAL IS NULL)
   LOOP
      FOR C_SOLICOMPRA IN (SELECT I.CDFILSOLI, P.CDPRODINTE AS CDPRODUTO, P.SGUNIDADE, I.DTPROGENTR, SUM(I.QTSOLIPROD) QTSOLIPROD
                             FROM ITEMSOLI I, (SELECT CDPRODUTO, CDPRODINTE, CDARVPROD, SGUNIDADE
                                                 FROM PRODUTO
                                                WHERE CDNVPRODUTO = '5') P
                            WHERE I.CDFILSOLI = C_FILIAL.CDFILIAL
                              AND I.CDPRODUTO = P.CDPRODUTO
                              AND I.DTPROGENTR BETWEEN V_DTINI AND V_DTFIN
                              AND NVL(I.USR_SHA_INTEGRADO, 'N') = 'N'
                              AND NVL(I.IDSOLIAPROV, 'N')       = 'S'
                              AND NOT P.CDPRODINTE IS NULL
                             GROUP BY I.CDFILSOLI, P.CDPRODINTE, P.SGUNIDADE, I.DTPROGENTR)
      LOOP
         V_ERRO := NULL;
         V_OBS  := NULL;

         INSERT INTO USR_ITEMSOLI_SHA(CDFILISOLI, CDPRODUTO, SGUNIDMED, DTPROGENTR, QTSOLIPROD)
         VALUES (C_FILIAL.CDEXFILIAL, C_SOLICOMPRA.CDPRODUTO, C_SOLICOMPRA.SGUNIDADE, C_SOLICOMPRA.DTPROGENTR, C_SOLICOMPRA.QTSOLIPROD);

         UPDATE ITEMSOLI
            SET USR_SHA_INTEGRADO = 'S'
          WHERE CDFILSOLI  = C_SOLICOMPRA.CDFILSOLI
            AND CDPRODUTO  = C_SOLICOMPRA.CDPRODUTO
            AND DTPROGENTR = C_SOLICOMPRA.DTPROGENTR;
      END LOOP;
   END LOOP;

   COMMIT;
   --DROPA O JOB AO ENCERRAR O PROCESSO
   BEGIN
      DBMS_SCHEDULER.DROP_JOB(V_NOME);
   EXCEPTION
      WHEN OTHERS THEN
           NULL;
   END;
EXCEPTION
WHEN OTHERS THEN
   V_ERRO := SQLERRM(SQLCODE);
   DBMS_OUTPUT.PUT_LINE(V_ERRO);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPORTA_SOLCOMP','6.45.024'); END;
/

